(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["SSuggestor"] = factory(require("react"));
	else
		root["SSuggestor"] = factory(root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
		value: true
	});
	exports.SSuggestor = exports.Suggestor = undefined;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	var _values = __webpack_require__(2);

	var _styles = __webpack_require__(3);

	var _withClickOut = __webpack_require__(4);

	var _withClickOut2 = _interopRequireDefault(_withClickOut);

	var _List = __webpack_require__(5);

	var _List2 = _interopRequireDefault(_List);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var Suggestor = exports.Suggestor = function (_PureComponent) {
		_inherits(Suggestor, _PureComponent);

		function Suggestor(props) {
			_classCallCheck(this, Suggestor);

			var _this = _possibleConstructorReturn(this, (Suggestor.__proto__ || Object.getPrototypeOf(Suggestor)).call(this, props));

			_this._bind('handleClick', 'handleChange', 'remove', 'handleKeyDown', 'handleItemClick', 'handleItemMouseEnter', 'handleClickOut', 'focus');

			_this.state = {
				value: props.value,
				filtered: props.list,
				open: false,
				index: 0
			};
			return _this;
		}

		_createClass(Suggestor, [{
			key: '_bind',
			value: function _bind() {
				var _this2 = this;

				for (var _len = arguments.length, methods = Array(_len), _key = 0; _key < _len; _key++) {
					methods[_key] = arguments[_key];
				}

				methods.forEach(function (method) {
					return _this2[method] = _this2[method].bind(_this2);
				});
			}
		}, {
			key: 'handleClickOut',
			value: function handleClickOut() {
				this.handleClose();
			}
		}, {
			key: 'componentWillReceiveProps',
			value: function componentWillReceiveProps(nextProps) {
				if (nextProps.value !== this.state.value) {
					this.setState({ value: nextProps.value });
				}
			}
		}, {
			key: 'handleClose',
			value: function handleClose() {
				this.setState({ open: false, filtered: this.props.list, index: 0 });
			}
		}, {
			key: 'toggleList',
			value: function toggleList() {
				if (this.state.open) {
					this.handleClose();
				} else {
					this.setState({
						open: true
					});
				}
			}
		}, {
			key: 'handleClick',
			value: function handleClick() {
				if (this.props.openOnClick) {
					this.toggleList();
				}
			}
		}, {
			key: 'handleKeyDown',
			value: function handleKeyDown(e) {
				this.props.onKey(e);
				if (!this.props.useKeys) {
					return;
				}
				var _state = this.state,
				    open = _state.open,
				    index = _state.index,
				    list = _state.filtered;


				switch (e.keyCode) {
					case _values.KEY_CODES.TAB:
						if (this.props.selectOnTab && open && list[index]) {
							this.changeValue(list[index], true);
						}
						this.handleClose();
						return;
					case _values.KEY_CODES.ENTER:
						this.toggleList();
						if (open && list[index]) {
							this.changeValue(list[index], true);
						}
						break;
					case _values.KEY_CODES.ESCAPE:
						this.handleClose();
						if (!open) {
							this.changeValue(_values.EMPTY_STR);
						}
						break;
					case _values.KEY_CODES.DOWN:
						{
							var next = (index + open) % list.length;
							this.setState({ open: true, index: next });
							break;
						}
					case _values.KEY_CODES.UP:
						{
							var prev = (index || list.length) - 1;
							this.setState({ open: true, index: prev });
							break;
						}
					default:
						return;
				}

				e.preventDefault();
			}
		}, {
			key: 'handleItemClick',
			value: function handleItemClick(value) {
				this.changeValue(value, true);
				if (!this.props.openOnClick) {
					this.toggleList();
				}
			}
		}, {
			key: 'handleItemMouseEnter',
			value: function handleItemMouseEnter(index) {
				this.setState({ index: index });
			}
		}, {
			key: 'handleChange',
			value: function handleChange(e) {
				e.stopPropagation();
				var value = e.target.value;
				var suggest = value.length >= this.props.suggestOn;
				var filtered = this.filter(value);
				var nextState = { filtered: filtered };
				if (!filtered.length || !suggest) {
					this.handleClose();
				} else {
					nextState.open = true;
				}
				this.setState(nextState);
				this.changeValue(value);
			}
		}, {
			key: 'remove',
			value: function remove() {
				this.changeValue(_values.EMPTY_STR, true);
			}
		}, {
			key: 'changeValue',
			value: function changeValue(value) {
				var _this3 = this;

				var select = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

				this.setState({ value: value }, function () {
					_this3.props.onChange(value);
					if (select) {
						_this3.props.onSelect(value);
					}
				});
			}
		}, {
			key: 'filter',
			value: function filter(value) {
				value = value.toLowerCase();
				return this.props.list.filter(function (item) {
					return item.toLowerCase().indexOf(value) !== -1;
				});
			}
		}, {
			key: 'focus',
			value: function focus() {
				this.refs.input.focus();
			}
		}, {
			key: 'render',
			value: function render() {
				var _props = this.props,
				    className = _props.className,
				    style = _props.style,
				    placeholder = _props.placeholder,
				    arrow = _props.arrow,
				    close = _props.close,
				    tooltip = _props.tooltip,
				    required = _props.required;
				var _state2 = this.state,
				    open = _state2.open,
				    value = _state2.value,
				    index = _state2.index,
				    list = _state2.filtered;


				return _react2.default.createElement(
					'div',
					{ className: className, style: style, onClick: this.handleClick, onKeyDown: this.handleKeyDown, ref: this.props.reference },
					_react2.default.createElement('input', { type: 'text', className: 'form-control', onChange: this.handleChange, value: value, ref: 'input', placeholder: placeholder, title: tooltip, required: required }),
					arrow && _react2.default.createElement('span', { className: 'glyphicon glyphicon-triangle-bottom', style: _styles.SPIN_STYLES }),
					close && value && _react2.default.createElement('span', { className: 'glyphicon glyphicon-remove', style: _styles.X_STYLES, onClick: this.remove }),
					_react2.default.createElement(_List2.default, _extends({ list: list, index: index, open: open, value: value }, { onItemClick: this.handleItemClick, onItemMouseEnter: this.handleItemMouseEnter }))
				);
			}
		}]);

		return Suggestor;
	}(_react.PureComponent);

	Suggestor.propTypes = {
		list: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.string).isRequired,
		reference: _react2.default.PropTypes.func,
		onChange: _react2.default.PropTypes.func,
		onSelect: _react2.default.PropTypes.func,
		onKey: _react2.default.PropTypes.func,
		value: _react2.default.PropTypes.string,
		openOnClick: _react2.default.PropTypes.bool,
		selectOnTab: _react2.default.PropTypes.bool,
		placeholder: _react2.default.PropTypes.string,
		tooltip: _react2.default.PropTypes.string,
		className: _react2.default.PropTypes.string,
		suggestOn: _react2.default.PropTypes.number,
		style: _react2.default.PropTypes.object,
		required: _react2.default.PropTypes.bool,
		useKeys: _react2.default.PropTypes.bool,
		arrow: _react2.default.PropTypes.bool,
		close: _react2.default.PropTypes.bool
	};

	var nop = function nop(_) {
		return _;
	};

	Suggestor.defaultProps = {
		className: 'input-group',
		onSelect: nop,
		onChange: nop,
		onKey: nop,
		value: _values.EMPTY_STR,
		openOnClick: true,
		selectOnTab: false,
		suggestOn: 1,
		required: false,
		useKeys: true,
		arrow: true,
		close: true
	};

	var SSuggestor = exports.SSuggestor = (0, _withClickOut2.default)(Suggestor);

	exports.default = SSuggestor;

/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ },
/* 2 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
		value: true
	});
	var EMPTY_STR = exports.EMPTY_STR = '';

	var KEY_CODES = exports.KEY_CODES = {
		TAB: 9,
		ENTER: 13,
		ESCAPE: 27,
		DOWN: 40,
		UP: 38
	};

/***/ },
/* 3 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
		value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var SPIN_STYLES = exports.SPIN_STYLES = {
		position: 'absolute',
		cursor: 'pointer',
		margin: 'auto',
		color: '#ccc',
		fontSize: 16,
		right: 10,
		top: 0,
		bottom: 0,
		height: 14,
		zIndex: 4
	};

	var X_STYLES = exports.X_STYLES = _extends({}, SPIN_STYLES, {
		fontSize: 14,
		right: 30
	});

	var getListStyles = exports.getListStyles = function getListStyles(visible) {
		return {
			display: visible ? 'block' : 'none',
			maxHeight: 250,
			minWidth: 30,
			width: 'inherit',
			overflow: 'auto',
			cursor: 'pointer'
		};
	};

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
		value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var withClickOut = function withClickOut(WrappedComponent) {
		var Wrapper = function (_Component) {
			_inherits(Wrapper, _Component);

			function Wrapper() {
				var _ref;

				_classCallCheck(this, Wrapper);

				for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
					args[_key] = arguments[_key];
				}

				var _this = _possibleConstructorReturn(this, (_ref = Wrapper.__proto__ || Object.getPrototypeOf(Wrapper)).call.apply(_ref, [this].concat(args)));

				_this.handleClick = _this.handleClick.bind(_this);
				_this.focus = _this.focus.bind(_this);
				return _this;
			}

			_createClass(Wrapper, [{
				key: 'componentDidMount',
				value: function componentDidMount() {
					document.addEventListener('click', this.handleClick);
				}
			}, {
				key: 'componentWillUnmount',
				value: function componentWillUnmount() {
					document.removeEventListener('click', this.handleClick);
				}
			}, {
				key: 'handleClick',
				value: function handleClick(e) {
					var wrapped = this.refs.wrapped;
					if (!this.node.contains(e.target) && typeof wrapped.handleClickOut === 'function') {
						wrapped.handleClickOut(e);
					}
				}
			}, {
				key: 'focus',
				value: function focus() {
					//todo: refactor to hoc withFocus (keep in mind nested components)
					this.refs.wrapped.focus();
				}
			}, {
				key: 'render',
				value: function render() {
					var _this2 = this;

					return _react2.default.createElement(WrappedComponent, _extends({ reference: function reference(node) {
							return _this2.node = node;
						}, ref: 'wrapped' }, this.props));
				}
			}]);

			return Wrapper;
		}(_react.Component);

		Wrapper.displayName = 'ClickOut(' + (WrappedComponent.displayName || WrappedComponent.name) + ')';
		return Wrapper;
	};

	exports.default = withClickOut;

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
		value: true
	});
	exports.List = undefined;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	var _ListItem = __webpack_require__(6);

	var _ListItem2 = _interopRequireDefault(_ListItem);

	var _styles = __webpack_require__(3);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var List = exports.List = function List(_ref) {
		var open = _ref.open,
		    list = _ref.list,
		    index = _ref.index,
		    value = _ref.value,
		    onItemClick = _ref.onItemClick,
		    onItemMouseEnter = _ref.onItemMouseEnter;
		return open && !!list.length && _react2.default.createElement(
			'ul',
			{ className: 'dropdown-menu', style: (0, _styles.getListStyles)(open) },
			list.map(function (item, i) {
				return _react2.default.createElement(_ListItem2.default, _extends({ key: i }, { item: item, onItemClick: onItemClick, onItemMouseEnter: onItemMouseEnter, search: value, index: i, overItem: index === i }));
			})
		);
	};

	List.propTypes = {
		list: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.string).isRequired,
		open: _react2.default.PropTypes.bool.isRequired,
		index: _react2.default.PropTypes.number.isRequired,
		onItemClick: _react2.default.PropTypes.func.isRequired,
		onItemMouseEnter: _react2.default.PropTypes.func.isRequired,
		value: _react2.default.PropTypes.string.isRequired
	};

	exports.default = List;

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
		value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	var _MarkItem = __webpack_require__(7);

	var _MarkItem2 = _interopRequireDefault(_MarkItem);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var ListItem = function (_PureComponent) {
		_inherits(ListItem, _PureComponent);

		function ListItem() {
			_classCallCheck(this, ListItem);

			return _possibleConstructorReturn(this, (ListItem.__proto__ || Object.getPrototypeOf(ListItem)).apply(this, arguments));
		}

		_createClass(ListItem, [{
			key: 'render',
			value: function render() {
				var _props = this.props,
				    item = _props.item,
				    onItemClick = _props.onItemClick,
				    onItemMouseEnter = _props.onItemMouseEnter,
				    index = _props.index,
				    overItem = _props.overItem,
				    search = _props.search;

				return _react2.default.createElement(
					'li',
					{ value: item, onClick: function onClick() {
							return onItemClick(item);
						}, onMouseEnter: function onMouseEnter() {
							return onItemMouseEnter(index, item);
						},
						style: { backgroundColor: overItem && '#f5f5f5' } },
					_react2.default.createElement(_MarkItem2.default, { item: item, search: search })
				);
			}
		}]);

		return ListItem;
	}(_react.PureComponent);

	ListItem.propTypes = {
		item: _react2.default.PropTypes.string.isRequired,
		index: _react2.default.PropTypes.number.isRequired,
		overItem: _react2.default.PropTypes.bool.isRequired,
		onItemClick: _react2.default.PropTypes.func.isRequired,
		onItemMouseEnter: _react2.default.PropTypes.func.isRequired,
		search: _react2.default.PropTypes.string.isRequired
	};

	exports.default = ListItem;

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
		value: true
	});

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var MarkItem = function MarkItem(_ref) {
		var item = _ref.item,
		    search = _ref.search;

		if (!search) {
			return _react2.default.createElement(
				'a',
				null,
				item
			);
		}

		var index = item.toLowerCase().indexOf(search.toLowerCase());
		if (index === -1) {
			return _react2.default.createElement(
				'a',
				null,
				item
			);
		}

		var searchLength = search.length;

		return _react2.default.createElement(
			'a',
			null,
			_react2.default.createElement(
				'span',
				null,
				item.substr(0, index),
				_react2.default.createElement(
					'strong',
					null,
					item.substr(index, searchLength)
				),
				item.substr(index + searchLength, item.length)
			)
		);
	};
	MarkItem.propTypes = {
		item: _react2.default.PropTypes.string.isRequired,
		search: _react2.default.PropTypes.string.isRequired
	};

	exports.default = MarkItem;

/***/ }
/******/ ])
});
;